#ifndef DMA_TFT_H
#define DMA_TFT_H

#include <stdio.h>
#include <stdint.h>

#include "tft_system.h"
#include "gpio_ports.h"         // verwendete Ports und Pins
#define nDE_MODE                // nicht implementiert
#define nMIT_BLINKEN            // Blinken braucht >= 256 KB RAM

#define EDT_TFT                 // touch X-Koordinate invertieren

#define ALTERNATIVE_SEITEN	0	// keine
#define BLINKEN			0x80	// in der Farbe enthalten
#define TRANSPARENT		0x40	// in der Farbe enthalten

#define SCHRIFT_BREITE	8		// Zeichenlnge
#define SCHRIFT_HOEHE	16		// Zeichenhhe
#define MAX_ZOOM	    15
#define MIN_ZOOM	    1

#define MAX_ZOOM_STACK  20      // LIFO Tiefe
#define MAX_XY_STACK    20      // LIFO Tiefe
#define MAX_COLOR_STACK 20      // LIFO Tiefe

#define BILDSPEICHER    SRAM_BILD
#define TFT_ADR         0x60000000	// CS-Bereich fr D0-D5

#define SCHWARZ			0x00
#define ROT			    0x03
#define GRUEN			0x0c
#define BLAU			0x30
#define WEISS			(ROT+BLAU+GRUEN)
#define GELB			(ROT+GRUEN)
#define TUERKIS			(0x2d)
#define VIOLETT			(BLAU+GRUEN)
#define HELLGRAU        0x2a
#define DUNKELGRAU      0x15

// fr WQVGA 480 x 272
#define SIZE_X			480
#define SIZE_Y			272
#define X_START_POS		43		// x-werte ab 43 Bildlage horizontal
#define Y_START_POS		12      // Zeilen ab 12 Bildlage vertikal
#define THP			    20		// Hsync lnge
#define	TVP			    2		// Vsync lnge in H-Zeilen

#define MAX_X			(SIZE_X-1)
#define MAX_Y			(SIZE_Y-1)

#define BILDBREITE		SIZE_X
#define BILDHOEHE		SIZE_Y
#define BILDGROESSE     (BILDBREITE * BILDHOEHE)


#define H_LINE_LEN		(BILDBREITE+X_START_POS)    // gesamte Zeile
#define V_LEN			(SIZE_Y+Y_START_POS)
#define HSYNC_ADR_MASKE		0x20000	                // A16 aktiv, wenn 0
#define VSYNC_ADR_MASKE		0x40000	                // A17 aktiv, wenn 0
#define DE_ADR_MASKE		0x80000	                // A18 aktiv, wenn 0

#define ZEICHEN_LAENGE	    aktuelle_schrift[0]     // Zeichenlnge
#define ZEICHEN_HOEHE		aktuelle_schrift[1]     // Zeichenhhe

// ein paar Steuezeichen
#define GLOCKE  7
#define LF      10
#define RTN     13
#define HOME    0x0b
#define CLEAR   0x0c
#define ESC     27

#endif